/****************************************************************************\
*  *
* File 'egl.cpp'  - EXeLENZ Graphics Library $Revision: 6 $
* Project started - 22:34:39, 20.09.97                                       *
* Last modifyed   - $Date: 14.03.99 12:21 $
*                                                                            *
* Written by EXeLENZ (55:1055/2@general, 2:5030/448.1@fidonet)               *
* Changes and additions by Yoletir (55:1055/246@general, 2:5030/654@fidonet) *
*  *
*/

#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>

#include "EGL_DD.h"
#include "egl_serv.h"
#include "egl_defs.h"

#include <windows.h>
#include <ddraw.h>

VBuffer EGLvBuffer;             // 稩  

static IDirectDraw        *pDD = NULL;
static IDirectDrawSurface *pPrimary;
static IDirectDrawSurface *pBack;
static IDirectDrawClipper *pClipper;

static int XResolution, YResolution, IsFullscreen, WndXStart, WndYStart, BufX, BufY;
int NoStretch=0;

char EGLbytesPerPixel;

unsigned short *ScaleBuf = NULL;

////
// 樠/⨥/㦥 㭪樨                                 //
////

#define SPRINTF_DDERR(x,y) case x : sprintf (buf, y); break
#define TRACE_DDERR(x) SPRINTF_DDERR(x,#x)

static void TraceLastDDrawError (HRESULT hResult, char *buf)
{
  switch (hResult)
  {
    TRACE_DDERR (DDERR_ALREADYINITIALIZED);
    TRACE_DDERR (DDERR_CANNOTATTACHSURFACE);
    TRACE_DDERR (DDERR_CANNOTDETACHSURFACE);
    TRACE_DDERR (DDERR_CURRENTLYNOTAVAIL);
    TRACE_DDERR (DDERR_EXCEPTION);
    TRACE_DDERR (DDERR_GENERIC);
    TRACE_DDERR (DDERR_HEIGHTALIGN);
    TRACE_DDERR (DDERR_INCOMPATIBLEPRIMARY);
    TRACE_DDERR (DDERR_INVALIDCAPS);
    TRACE_DDERR (DDERR_INVALIDCLIPLIST);
    TRACE_DDERR (DDERR_INVALIDMODE);
    TRACE_DDERR (DDERR_INVALIDOBJECT);
    TRACE_DDERR (DDERR_INVALIDPARAMS);
    TRACE_DDERR (DDERR_INVALIDPIXELFORMAT);
    TRACE_DDERR (DDERR_INVALIDRECT);
    TRACE_DDERR (DDERR_LOCKEDSURFACES);
    TRACE_DDERR (DDERR_NO3D);
    TRACE_DDERR (DDERR_NOALPHAHW);
    TRACE_DDERR (DDERR_NOCLIPLIST);
    TRACE_DDERR (DDERR_NOCOLORCONVHW);
    TRACE_DDERR (DDERR_NOCOOPERATIVELEVELSET);
    TRACE_DDERR (DDERR_NOCOLORKEY);
    TRACE_DDERR (DDERR_NOCOLORKEYHW);
    TRACE_DDERR (DDERR_NODIRECTDRAWSUPPORT);
    TRACE_DDERR (DDERR_NOEXCLUSIVEMODE);
    TRACE_DDERR (DDERR_NOFLIPHW);
    TRACE_DDERR (DDERR_NOGDI);
    TRACE_DDERR (DDERR_NOMIRRORHW);
    TRACE_DDERR (DDERR_NOTFOUND);
    TRACE_DDERR (DDERR_NOOVERLAYHW);
    TRACE_DDERR (DDERR_NORASTEROPHW);
    TRACE_DDERR (DDERR_NOROTATIONHW);
    TRACE_DDERR (DDERR_NOSTRETCHHW);
    TRACE_DDERR (DDERR_NOT4BITCOLOR);
    TRACE_DDERR (DDERR_NOT4BITCOLORINDEX);
    TRACE_DDERR (DDERR_NOT8BITCOLOR);
    TRACE_DDERR (DDERR_NOTEXTUREHW);
    TRACE_DDERR (DDERR_NOVSYNCHW);
    TRACE_DDERR (DDERR_NOZBUFFERHW);
    TRACE_DDERR (DDERR_NOZOVERLAYHW);
    TRACE_DDERR (DDERR_OUTOFCAPS);
    TRACE_DDERR (DDERR_OUTOFMEMORY);
    TRACE_DDERR (DDERR_OUTOFVIDEOMEMORY);
    TRACE_DDERR (DDERR_OVERLAYCANTCLIP);
    TRACE_DDERR (DDERR_OVERLAYCOLORKEYONLYONEACTIVE);
    TRACE_DDERR (DDERR_PALETTEBUSY);
    TRACE_DDERR (DDERR_COLORKEYNOTSET);
    TRACE_DDERR (DDERR_SURFACEALREADYATTACHED);
    TRACE_DDERR (DDERR_SURFACEALREADYDEPENDENT);
    TRACE_DDERR (DDERR_SURFACEBUSY);
    TRACE_DDERR (DDERR_CANTLOCKSURFACE);
    TRACE_DDERR (DDERR_SURFACEISOBSCURED);
    TRACE_DDERR (DDERR_SURFACELOST);
    TRACE_DDERR (DDERR_SURFACENOTATTACHED);
    TRACE_DDERR (DDERR_TOOBIGHEIGHT);
    TRACE_DDERR (DDERR_TOOBIGSIZE);
    TRACE_DDERR (DDERR_TOOBIGWIDTH);
    TRACE_DDERR (DDERR_UNSUPPORTED);
    TRACE_DDERR (DDERR_UNSUPPORTEDFORMAT);
    TRACE_DDERR (DDERR_UNSUPPORTEDMASK);
    TRACE_DDERR (DDERR_VERTICALBLANKINPROGRESS);
    TRACE_DDERR (DDERR_WASSTILLDRAWING);
    TRACE_DDERR (DDERR_XALIGN);
    TRACE_DDERR (DDERR_INVALIDDIRECTDRAWGUID);
    TRACE_DDERR (DDERR_DIRECTDRAWALREADYCREATED);
    TRACE_DDERR (DDERR_NODIRECTDRAWHW);
    TRACE_DDERR (DDERR_PRIMARYSURFACEALREADYEXISTS);
    TRACE_DDERR (DDERR_NOEMULATION);
    TRACE_DDERR (DDERR_REGIONTOOSMALL);
    TRACE_DDERR (DDERR_CLIPPERISUSINGHWND);
    TRACE_DDERR (DDERR_NOCLIPPERATTACHED);
    TRACE_DDERR (DDERR_NOHWND);
    TRACE_DDERR (DDERR_HWNDSUBCLASSED);
    TRACE_DDERR (DDERR_HWNDALREADYSET);
    TRACE_DDERR (DDERR_NOPALETTEATTACHED);
    TRACE_DDERR (DDERR_NOPALETTEHW);
    TRACE_DDERR (DDERR_BLTFASTCANTCLIP);
    TRACE_DDERR (DDERR_NOBLTHW);
    TRACE_DDERR (DDERR_NODDROPSHW);
    TRACE_DDERR (DDERR_OVERLAYNOTVISIBLE);
    TRACE_DDERR (DDERR_NOOVERLAYDEST);
    TRACE_DDERR (DDERR_INVALIDPOSITION);
    TRACE_DDERR (DDERR_NOTAOVERLAYSURFACE);
    TRACE_DDERR (DDERR_EXCLUSIVEMODEALREADYSET);
    TRACE_DDERR (DDERR_NOTFLIPPABLE);
    TRACE_DDERR (DDERR_CANTDUPLICATE);
    TRACE_DDERR (DDERR_NOTLOCKED);
    TRACE_DDERR (DDERR_CANTCREATEDC);
    TRACE_DDERR (DDERR_NODC);
    TRACE_DDERR (DDERR_WRONGMODE);
    TRACE_DDERR (DDERR_IMPLICITLYCREATED);
    TRACE_DDERR (DDERR_NOTPALETTIZED);
    TRACE_DDERR (DDERR_UNSUPPORTEDMODE);
    TRACE_DDERR (DDERR_NOMIPMAPHW);
    TRACE_DDERR (DDERR_INVALIDSURFACETYPE);
    TRACE_DDERR (DDERR_DCALREADYCREATED);
    TRACE_DDERR (DDERR_CANTPAGELOCK);
    TRACE_DDERR (DDERR_CANTPAGEUNLOCK);
    TRACE_DDERR (DDERR_NOTPAGELOCKED);
    TRACE_DDERR (DDERR_NOTINITIALIZED);
    default : sprintf (buf, "Unknown DirectDraw error %i\n", hResult);
  } 
}

static BOOL ReportFailure (HWND hWnd, HRESULT hr)
{
   EGLterminate();

   char buf [128], buf2 [128];
   TraceLastDDrawError (hr, buf);
   sprintf (buf2, "DirectDraw initialization failed: %s", buf);
   MessageBox (hWnd, buf2, "Electron Soccer", MB_OK);
   DestroyWindow (hWnd);
   return FALSE;
}

struct EGLmodeEnum {
   unsigned int x, y, bpp;
   int available;
};

static HRESULT WINAPI ModeCallback (LPDDSURFACEDESC pddsd, void *pContext)
{
   EGLmodeEnum *e=(EGLmodeEnum *) pContext;

   int AvailBPP=pddsd->ddpfPixelFormat.dwRGBBitCount;

   if (e->x == pddsd->dwWidth && e->y == pddsd->dwHeight &&
       (e->bpp == AvailBPP || (e->bpp==15 && AvailBPP==16) || (e->bpp==16 && AvailBPP==15))) {
      e->available = 1;
      return DDENUMRET_CANCEL;
   }
   
   return DDENUMRET_OK;
}

/****************************************************************************\
* Function : EGLhaveMode                                                     *
* Desc     : ।, 㯥  ᪨ ०  㦭묨 ࠬࠬ *
* Input    : ࠧ襭, bpp                                                 *
* Output   : ᯥ譮/㤠筮                                                *
****************************************************************************/
int EGLhaveMode (int x, int y, int bpp) {

   if (!pDD) DirectDrawCreate (NULL, &pDD, NULL);

   EGLmodeEnum e;
   e.x=x; e.y=y; e.bpp=bpp; e.available=0;

   pDD->EnumDisplayModes (0, NULL, &e, ModeCallback);

   return e.available;
}

/****************************************************************************\
* Function : EGLinitDirectDraw                                               *
* Desc     : ⠢ 㦭 ᪨ ०                                 *
* Input    : handle , ࠧ襭                                         *
* Output   : ᯥ譮/㤠筮                                                *
\****************************************************************************/

int EGLinitDirectDraw (HWND hWnd, int x, int y, int bpp, int bFullscreen,
                      int BufX, int BufY, int bNoStretch) {
   int hr;
   
   if (!pDD) {
      hr=DirectDrawCreate (NULL, &pDD, NULL);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);
   }

   if (bFullscreen) {
      hr=pDD->SetCooperativeLevel (hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);
      hr=pDD->SetDisplayMode (x, y, bpp);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);
   } else {
      hr=pDD->SetCooperativeLevel (hWnd, DDSCL_NORMAL);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);
   }

   switch (bpp) {
      case 4:  EGLbytesPerPixel=1;break;
      case 8:  EGLbytesPerPixel=1;break;
      case 15: EGLbytesPerPixel=2;break;
      case 16: EGLbytesPerPixel=2;break;
      case 24: EGLbytesPerPixel=4;break;
      case 32: EGLbytesPerPixel=4;break;
      default: EGLbytesPerPixel=1;
   }
   XResolution = x; YResolution = y; IsFullscreen = bFullscreen;
   ::BufX = BufX; ::BufY = BufY;
   NoStretch = bNoStretch;

   DDSURFACEDESC ddsd;
   DDSCAPS       ddscaps;

   ddsd.dwSize = sizeof (ddsd);
   if (bFullscreen) {
         
      // initialize surface desc
      ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
   
      ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                            DDSCAPS_FLIP |
                            DDSCAPS_COMPLEX;
      ddsd.dwBackBufferCount = 2;
   
      // create primary surface
      hr=pDD->CreateSurface (&ddsd, &pPrimary, NULL);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);
   
      // get back surface
      ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
      hr=pPrimary->GetAttachedSurface (&ddscaps, &pBack);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);

      // clear primary and back surface
      DDBLTFX bltfx;
      bltfx.dwSize = sizeof (bltfx);
      bltfx.dwFillColor = 0;

      pPrimary->Blt (NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
      pBack->Blt (NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);

      WndXStart = 0;
      WndYStart = 0;
   } else {
      ddsd.dwFlags = DDSD_CAPS;
      ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

      // create primary surface
      hr=pDD->CreateSurface (&ddsd, &pPrimary, NULL);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);

      // create clipper
      hr=pDD->CreateClipper (0, &pClipper, NULL);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);

      hr=pClipper->SetHWnd (0, hWnd);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);

      hr=pPrimary->SetClipper (pClipper);
      if (hr != DD_OK) return ReportFailure (hWnd, hr);
   }

   if (ScaleBuf != NULL) free (ScaleBuf);
   ScaleBuf = (unsigned short *) malloc (BufX*2*EGLbytesPerPixel);

   // debug: print out the pixel format we've got
   DDPIXELFORMAT ddpf;
   ddpf.dwSize = sizeof (DDPIXELFORMAT);
   pPrimary->GetPixelFormat (&ddpf);
   char buf [128];
   sprintf (buf, "Pixel format: R %08X, G %08X, B %08X\n",
           ddpf.dwRBitMask, ddpf.dwGBitMask, ddpf.dwBBitMask);
   OutputDebugString (buf);

   return EGLok;
}

void EGLsetWindowRect (LPRECT rect)
{
   WndXStart = rect->left;
   WndYStart = rect->top;
}

/****************************************************************************\
* Function : EGLterminate                                                    *
* Desc     : 蠥 EGL                                                   *
* Input    :                                                             *
* Output   :                                                             *
\****************************************************************************/
void EGLterminate (void)
{
   if (pDD != NULL) {
      if (pClipper != NULL) {
         pClipper->Release();
         pClipper = NULL;
      }
      
      if (pPrimary != NULL) {
         pPrimary->Release();
         pPrimary = NULL;
      }
      pDD->Release();
      pDD = NULL;
   }
   if (ScaleBuf != NULL) free (ScaleBuf);
}

////
// 㭪樨  ࠡ  㠫묨 ࠭.                              //
////

/****************************************************************************\
* Function : EGLcreateVBuffer                                                *
* Desc     :  㠫 .                                     *
* Input    : ⢥                                                *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLcreateVBuffer (VBuffer * buffer)
{
   if (buffer == NULL) return EGLerror;

   // ।塞 ᮪ .
   if ((*buffer=(VBuffer) malloc
      (BufX*BufY*EGLbytesPerPixel))==NULL)
      return (EGLerror);

   // 塞 .
   memset (*buffer,0,BufX*BufY*EGLbytesPerPixel);

   return (EGLok);
}

/****************************************************************************\
* Function : EGLsetActiveVBuffer                                             *
* Desc     : ⠭ ⨢                                     *
* Input    : ⢥                                                 *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLsetActiveVBuffer (VBuffer buffer)
{
   if (buffer == NULL) return EGLerror;

   // ⠢ 㪠⥫  ࠡ稩 ࠭ ࠢ buffer.
   EGLvBuffer=buffer;

   return EGLok;
}

/****************************************************************************\
* Function : EGLclearVBuffer                                                 *
* Desc     : 頥                                                   *
* Input    : ⢥                                                *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLclearVBuffer (VBuffer buffer) {
   if (buffer == NULL) return EGLerror;

   memset (buffer,0,BufX*BufY*EGLbytesPerPixel);
   return EGLok;
}

/****************************************************************************\
* Function : EGLdrawVBuffer                                                  *
* Desc     :   ࠭ buffer.                                        *
* Input    :  ࠭                                                      *
* Output   : ok/error                                                        *
\****************************************************************************/
int EGLdrawVBuffer (VBuffer buffer)
{
   //OutputDebugString ("\nEGLdrawVBuffer ");
   if (buffer == NULL) return EGLerror;

   if (pPrimary->IsLost() == DDERR_SURFACELOST)
      pPrimary->Restore();

   DDSURFACEDESC ddsd;
   ddsd.dwSize = sizeof (ddsd);

   if (IsFullscreen) {
      if (pBack->Lock (NULL, &ddsd, DDLOCK_WAIT, NULL) != DD_OK) {
         //OutputDebugString ("Lock failed\n");
         return EGLerror;
      }
   } else {
      if (pPrimary->Lock (NULL, &ddsd, DDLOCK_WAIT, NULL) != DD_OK)
         return EGLerror;
   }

   if (NoStretch) {
      unsigned char *p = buffer;
      unsigned int RowSize=BufX*EGLbytesPerPixel;
      unsigned char *dp = (unsigned char *) ddsd.lpSurface +
         WndYStart*ddsd.lPitch + WndXStart*EGLbytesPerPixel;
      for (int cy=0; cy<BufY; cy++) {
         memcpy (dp, p, RowSize);
         p += RowSize;
         dp += ddsd.lPitch;
      }
   } else {
      // 16 bpp only!!!
      unsigned int RowSize=BufX*2*EGLbytesPerPixel;
      unsigned char *dp=(unsigned char *) ddsd.lpSurface +
         WndYStart*ddsd.lPitch + WndXStart*EGLbytesPerPixel;
      unsigned short *p=(unsigned short *) buffer;
         
      for (int cy=0; cy<BufY; cy++) {
         unsigned short *sp=ScaleBuf;
         for (int cx=0; cx<BufX; cx++) {
            *sp++=*p;
            *sp++=*p++;
         }
         memcpy (dp, ScaleBuf, RowSize);
         dp += ddsd.lPitch;
         memcpy (dp, ScaleBuf, RowSize);
         dp += ddsd.lPitch;
      }
   }

   if (IsFullscreen) {
      if (pBack->Unlock (NULL) != DD_OK) {
         //OutputDebugString ("Unlock failed");
         return EGLerror;
      }
   
      if (pPrimary->Flip (NULL, DDFLIP_WAIT) != DD_OK) {
         //OutputDebugString ("Flip failed");
         return EGLerror;
      }
   } else {
      if (pPrimary->Unlock (NULL) != DD_OK)
         return EGLerror;
   }

   return EGLok;
}

////
// 㭪樨  ࠡ  ࠩ⠬.                                         //
////

/****************************************************************************\
* Function : EGLallocBlock                                                   *
* Desc     : ।   ࠩ.                                 *
* Input    : BitMap, X size of image, Y size of image                        *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLallocBlock (BitMap ** block,
                   short xsize,
                   short ysize)
{
   if (block == NULL) return EGLerror;

   // Allocate needed mem block
   (*block)=(struct BitMap *) malloc (sizeof (BitMap));

   uchar *temp=(uchar *) malloc ((int)xsize*(int)(ysize+2)*EGLbytesPerPixel);
   if (temp==NULL) return (EGLerror);

   // 뢠 block'   ᮪ 
   (*block)->Image=temp;

   // ⠢ ࠧ ࠩ
   (*block)->XSize=xsize;
   (*block)->YSize=ysize;

   return (EGLok);
}

/****************************************************************************\
* Function : EGLfreeBlock                                                    *
* Desc     : ᢮  - ࠩ =)                            *
* Input    : BitMap                                                          *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLfreeBlock (BitMap * block)
{
   if (block == NULL) return EGLerror;

   if (block->Image != NULL) free (block->Image);
   free (block);
   return EGLok;
}

/****************************************************************************\
* Function : EGLgetBlock                                                     *
* Desc     : Stores rectangle region of VBuffer in BitMap                    *
* Input    : Destination bitmap, x ,y ,xrl ,yrl                              *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLgetBlock (BitMap* block,
                  ushort x,
                  ushort y,
                  ushort xrl,
                  ushort yrl)
{

   if (block == NULL) return EGLerror;

   block->XSize=xrl-x+1;                  /* Adjust block X size            */
   block->YSize=yrl-y+1;                  /* Adjust block Y size            */

//   if (y<0) y=0; if (y>ModeMaxY) y=ModeMaxY;
//   if (x<0) x=0; if (x>ModeMaxX) x=ModeMaxX;

//   if (yrl<0) yrl=0; if (yrl>ModeMaxY) yrl=ModeMaxY;
//   if (xrl<0) xrl=0; if (xrl>ModeMaxX) xrl=ModeMaxX;

   int xpos_start=x*EGLbytesPerPixel, xpos_end=xrl*EGLbytesPerPixel;
   for (ushort yc=y; yc<=yrl; yc++) {
      memcpy (block->Image + ((yc-y)*block->XSize)*EGLbytesPerPixel,
              EGLvBuffer + (yc*BufX+x)*EGLbytesPerPixel,
              (xrl-x+1)*EGLbytesPerPixel);
   }

   return EGLok;
}

/****************************************************************************\
* Function : EGLputBlock                                                     *
* Desc     : Puts rectangle region of picture in EGLvBuffer                  *
* Input    : Source bitmap, x ,y                                             *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLputBlock (BitMap* block,
                  ushort x,
                  ushort y) {

   if (block == NULL) return EGLerror;

   ushort xrl,yrl;

   if (y+block->YSize > BufY) yrl=BufY-y;
   else yrl = block->YSize;
   if (x+block->XSize > BufX) xrl=BufX-x;
   else xrl = block->XSize;

   for (ushort yc=0; yc<yrl; yc++) {
      memcpy (EGLvBuffer + ((yc+y)*BufX+x)*EGLbytesPerPixel,
              block->Image + (yc*block->XSize)*EGLbytesPerPixel,
              xrl*EGLbytesPerPixel);
   }

   return EGLok;
}

/****************************************************************************\
* Function : EGLwaitVRetrace                                                 *
* Desc     :  ⭮ 室 .                                       *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void EGLwaitVRetrace (void) {
   // just a stub, for now
}

/****************************************************************************\
* Function : EGLgetPixelFormat                                               *
* Desc     : Gets pixel format of the screen (R,G,B masks)                   *
* Input    : None                                                            *
* Output   : Masks                                                           *
\****************************************************************************/
int EGLgetPixelFormat (ulong *RMask, ulong *GMask, ulong *BMask) {

   DDPIXELFORMAT ddpf;
   ddpf.dwSize = sizeof (DDPIXELFORMAT);
   if (pPrimary->GetPixelFormat (&ddpf) != DD_OK)
      return EGLerror;

   if (ddpf.dwFlags & DDPF_RGB == 0)
      return EGLerror;
   *RMask = ddpf.dwRBitMask;
   *GMask = ddpf.dwGBitMask;
   *BMask = ddpf.dwBBitMask;

   return EGLok;
}
