#ifndef __EGL_H
#define __EGL_H

/****************************************************************************\
* $Header: /C/ElSocc/EGL_DD/EGL_DD.h 6     14.03.99 12:21 Yole $
*  *
* File 'egl.h'  - Definitions for EGL                                        *
* Last modifyed - 22:11:43, 20.09.97                                         *
*                                                                            *
* Written by EXeLENZ (55:1055/2@general, 2:5030/448.1@fidonet)               *
* Changes and additions by Yoletir (55:1055/246@general, 2:5030/654@fidonet) *
*  *
\****************************************************************************/

#include "egl_defs.h"
#include <windows.h>

typedef unsigned char * VBuffer;      // Type - Video Buffer
typedef char  Bool;                   // Type - boolean expression
typedef int   EGLcolor;               // color of a pixel

extern char    EGLbytesPerPixel;      //   ᥫ ᪮쪮
extern VBuffer EGLvBuffer;            // 騩 

struct BitMap {                       // BitMap - image holds size and
   ushort XSize;                      // pointer to image
   ushort YSize;
   uchar* Image;
};

/****************************************************************************\
* Function : EGLwaitVRetrace                                                 *
* Desc     :  ⭮ 室 .                                       *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void EGLwaitVRetrace (void);

////
// 樠/⨥/㦥 㭪樨                                 //
////


/****************************************************************************\
* Function : EGLhaveMode                                                     *
* Desc     : ।, 㯥  ᪨ ०  㦭묨 ࠬࠬ *
* Input    : ࠧ襭, bpp                                                 *
* Output   : ᯥ譮/㤠筮                                                *
****************************************************************************/
int EGLhaveMode (int x, int y, int bpp);

/****************************************************************************\
* Function : EGLinitDirectDraw                                               *
* Desc     : ⠢ 㦭 ᪨ ०                                 *
* Input    : handle , ࠧ襭                                         *
* Output   : ᯥ譮/㤠筮                                                *
****************************************************************************/
int EGLinitDirectDraw (HWND hWnd, int x, int y, int bpp, int bFullscreen,
                      int BufX, int BufY, int bNoStretch);

void EGLsetWindowRect (LPRECT rect);

/****************************************************************************\
* Function : EGLterminate                                                    *
* Desc     : 蠥 EGL                                                   *
* Input    :                                                             *
* Output   :                                                             *
\****************************************************************************/
void EGLterminate (void);

////
// 㭪樨  ࠡ  㠫묨 ࠭.                              //
////

/****************************************************************************\
* Function : EGLcreateVBuffer                                                *
* Desc     :  㠫 .                                     *
* Input    : ⢥                                                *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLcreateVBuffer (VBuffer * buffer);

/****************************************************************************\
* Function : EGLsetActiveVBuffer                                             *
* Desc     : ⠭ ⨢                                    *
* Input    : ⢥                                                *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLsetActiveVBuffer (VBuffer buffer);

/****************************************************************************\
* Function : EGLclearVBuffer                                                 *
* Desc     : 頥                                                   *
* Input    : ⢥                                                *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLclearVBuffer (VBuffer buffer);

/****************************************************************************\
* Function : EGLdrawVBuffer                                                  *
* Desc     :   ࠭ buffer.                                        *
* Input    :  ࠭                                                      *
* Output   : ᯥ譮/ᯥ譮                                               *
\****************************************************************************/
int EGLdrawVBuffer (VBuffer buffer);


////
// 㭪樨  ࠡ  ࠩ⠬.                                         //
////

/****************************************************************************\
* Function : EGLallocBlock                                                   *
* Desc     : ।   ࠩ.                                 *
* Input    : BitMap, X size of image, Y size of image                        *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLallocBlock (BitMap ** block,
                   short xsize,
                   short ysize);

/****************************************************************************\
* Function : EGLfreeBlock                                                    *
* Desc     : ᢮  - ࠩ =)                            *
* Input    : BitMap                                                          *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLfreeBlock (BitMap * block);

/****************************************************************************\
* Function : EGLgetBlock                                                     *
* Desc     : Stores rectangle region of VBuffer in BitMap                    *
* Input    : Destination bitmap, x ,y ,xrl ,yrl                              *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLgetBlock (BitMap* block,
                  ushort x,
                  ushort y,
                  ushort xrl,
                  ushort yrl);

/****************************************************************************\
* Function : EGLputBlock                                                     *
* Desc     : Puts rectangle region of picture in EGLvBuffer                  *
* Input    : Source bitmap, x ,y                                             *
* Output   : EGLok/EGLerror                                                  *
\****************************************************************************/
int EGLputBlock (BitMap* block,
                 ushort x,
                 ushort y);

/****************************************************************************\
* Function : EGLgetPixelFormat                                               *
* Desc     : Gets pixel format of the screen (R,G,B masks)                   *
* Input    : None                                                            *
* Output   : Masks                                                           *
\****************************************************************************/
int EGLgetPixelFormat (ulong *RMask, ulong *GMask, ulong *BMask);

#endif

/*
 * $Log: /C/ElSocc/EGL_DD/EGL_DD.h $
 * 
 * 6     14.03.99 12:21 Yole
 * EGLhaveMode added
 * 
 * 5     5.01.99 1:09 Yole
 * supports stretching
 * 
 * 4     4.01.99 0:56 Yole
 * windowed mode support (incomplete)
 * 
 * 3     2.01.99 13:38 Yole
 * fixed EGLgetBlock/EGLputBlock
 * 
 * 2     31.12.98 1:31 Yole
 * work in progress
 * 
 * 1     26.12.98 0:48 Yole
 * Quick & dirty port of EGL under DirectDraw
*/