/****************************************************************************\
*  *
* File 'el_socc.h'    - definitions for Electron Soccer                      *
* Project started     - 14:54:21, 18-11-97                                   *
* Last modifyed       - 19:33:44,  1-12-97                                   *
*                                                                            *
* Written by EXeLENZ (55:1055/2@general, 2:5030/448.1@fidonet)               *
*  *
\****************************************************************************/

#include <egl.h>
#include <egl_serv.h>
#include <egl_defs.h>

#include <midasdll.h>                 /*  =)                           */

#define hitAll  1
#define hitMain 2
#define mess    3

#define YES     1
#define NO      0

#define PRESSED   1
#define DEPRESSED 0

#define Lower     1
#define Upper     2

#define VorX      136
#define VorSize   48


#define DISSOLVE_BALLS
#define USE_MIDAS

const double rad=57.295779513;        /* ࠢ쭮, ⮬ ࠢ 1 ࠤ =) */

//  । 쥪⮢
struct Qelem {

   int Id;                             /*  쥪                     */

   BitMap * image;                     /* ⨭                          */
   BitMap * bgr;                       /*  ⨭ =)              */

   float speed;                        /*  쥪 90             */
   double xspeed;                      /*       y                */
   double yspeed;                      /*        x0 */
   double x;                           /*  न ( 孨 㣮) */
   double y;                           /* Y न                      */

   double ox;                          /*  न ( 孨 㣮) */
   double oy;                          /* Y न ( ।. 蠣)  */

   short weight;                       /*  쥪                     */

   Qelem * LastCollide;                /* ᫥ ⮫            */

   short left;                         /*   ॠ 쥪 ()  */
   short right;                        /*   ॠ 쥪 (ࠢ) */
   short up;                           /*   ॠ 쥪 ()   */
   short down;                         /*   ॠ 쥪 ()    */

   char mode;                          /* hitAll  - ਠ       */
                                       /* hitMain - ਠ ⮫쪮    */
                                       /*           쥪 ⨯ hitAll     */
                                       /* mess    - 쥪 ⨯ message    */

   Qelem * next;                       /* 騩 쥪                  */
   Qelem * prev;                       /* ।騩 쥪                  */
};

extern char keymap [128];
extern int NOSOUND, NOPLASMA, NOMUSIC;
extern VBuffer screen1;

/*  㠫쭮 ࠭ */
enum { MaxX=320, MaxY=200 };
/*  ஢ ࠭ (। 䨪) */
enum { GameMaxX=320, GameMaxY=200 };
/*    䮭 */
enum { PlasmaX=302, PlasmaY=166 };
/* ० (ࠧ ) */
extern int VidMaxX, VidMaxY;

#ifdef USE_MIDAS
extern int m_error;
#endif

extern double GameSpeed;
extern int GameTime;

void Intro (void);
void Game (void);

void KbdHandler (void);
void ControlObject (Qelem * elem);

void InitObjQueue (void);
void DestroyQueue (void);

void AddObjToQueue (Qelem TempElem);

/****************************************************************************\
* Function : ProcessQueue                                                    *
* Desc     : Manages all objects in queue (moves them, etz)                  *
* Input    : None                                                            *
* Output   : Goal status                                                     *
\****************************************************************************/
int ProcessQueue (long FrameElapsed);

void WriteScores (void);

/****************************************************************************\
* Function : WriteTime                                                       *
* Desc     : Draws time left                                                 *
* Input    : Time left                                                       *
* Output   : None                                                            *
\****************************************************************************/
void WriteTime (int timeLeft);

void AddObjects (void);

void BounceWalls   (Qelem * curElem, double move_x, double move_y);
void BounceObjects (Qelem * curElem);

/****************************************************************************\
* Function : CheckGoal                                                       *
* Desc     : Checks for winning conditions                                   *
* Input    : Object to handle                                                *
* Output   : Goal status                                                     *
\****************************************************************************/
int CheckGoal (Qelem * curElem);

void greenWin (void);
void redWin (void);
void timeOver (void);

void dissolveBalls (void);

int EGLputBlockT (BitMap* block,
                  short x,
                  short y,
                  short tc);

void ScaleToVBuf (BitMap * source,
                  int newXsize,
                  int newYsize,
                  int x,
                  int y,
                  char * destination);

/****************************************************************************\
* Function : scaleOne                                                        *
* Desc     : Scales one object from nothing to full size                     *
* Input    : Object to scal and where to scale                               *
* Output   : None                                                            *
\****************************************************************************/
void scaleOne (BitMap * source, int xpl, int ypl, int localGoal=0);

/****************************************************************************\
* Function : RedS                                                            *
* Desc     : Update red component of pixel                                   *
* Input    : pixel, new value                                                *
* Output   : None                                                            *
\****************************************************************************/
void RedS (unsigned char * pix, int addr, unsigned short value);

/****************************************************************************\
* Function : RedR                                                            *
* Desc     : Get red component of pixel                                      *
* Input    : pixel                                                           *
* Output   : value                                                           *
\****************************************************************************/
unsigned short RedR (unsigned char * pix,int addr,int len);

/****************************************************************************\
* Function : GreenS                                                          *
* Desc     : Update green component of pixel                                 *
* Input    : pixel, new value                                                *
* Output   : None                                                            *
\****************************************************************************/
void GreenS (unsigned char * pix, int addr, unsigned short value);

/****************************************************************************\
* Function : GreenR                                                          *
* Desc     : Read green component of pixel                                   *
* Input    : pixel                                                           *
* Output   : value                                                           *
\****************************************************************************/
unsigned short GreenR (unsigned char * pix,int addr,int len);

/****************************************************************************\
* Function : BlueS                                                           *
* Desc     : Update blue component of pixel                                  *
* Input    : pixel, new value                                                *
* Output   : None                                                            *
\****************************************************************************/
void BlueS (unsigned char * pix, int addr, unsigned short value);

/****************************************************************************\
* Function : BlueR                                                           *
* Desc     : Read blue component of pixel                                    *
* Input    : pixel                                                           *
* Output   : value                                                           *
\****************************************************************************/
unsigned short BlueR (unsigned char * pix,int addr,int len);

int max3 (int a,
          int b,
          int c);

void Getch (void);

/****************************************************************************\
* Function : WaitRelease                                                     *
* Desc     : Waits till all keys are released                                *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void WaitRelease (void);

void Error (int cause);

/****************************************************************************\
* Function : DrawPlasma                                                      *
* Desc     : Generates plasma.                                               *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void DrawPlasma();

/****************************************************************************\
* Function : ConvertPlasma                                                   *
* Desc     : Converts plasma from indexed color to high color and            *
* Desc     : draws it at center of game screen.                              *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void ConvertPlasma (void);

/****************************************************************************\
* Function : GrHelp                                                            *
* Desc     : OnLine help                                                     *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void GrHelp (void);

/****************************************************************************\
* Function : RedefineKeys                                                      *
* Desc     : Redefinition of player keys                                     *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void RedefineKeys (void);

/****************************************************************************\
* Function : HRhan                                                           *
* Desc     : Handles help and redefine                                       *
* Input    : Object                                                          *
* Output   : None                                                            *
\****************************************************************************/
void HRhan (void);

/****************************************************************************\
* Function : MorphScreen                                                       *
* Desc     : Morphs one screen into another                                  *
* Input    : src & destination                                               *
* Output   : None                                                            *
\****************************************************************************/
void MorphScreen (unsigned char * source, unsigned char * destination);

/****************************************************************************\
* Function : getKey                                                          *
* Desc     : gets one keystroke                                              *
* Input    : None                                                            *
* Output   : key scanned                                                     *
\****************************************************************************/
char getKey (int x, int y);

/****************************************************************************\
* Function : Demix                                                           *
* Desc     : Restores and writes one file to sdisk                           *
* Input    : resource handle and file name                                   *
* Output   : None                                                            *
\****************************************************************************/
void Demix (int handle, char * name);

BitMap * EGLloadFFI (int handle);

/****************************************************************************\
* Function : EGLtrace                                                        *
* Desc     : ⫠筠                                                *
* Input    : ଠ⭠ ப, 㬥                                     *
* Output   :                                                              *
\****************************************************************************/
void __cdecl EGLtrace (char *fmt, ...);

/* ⥬-ᨬ 㭪樨 main  襭 */
void ElSoccMain();
void UpdatePixelFormat();
void UpdateBuffer (int OldMaxX, int OldMaxY);
void ElSoccDone();

void ProcessMessages();
void DeinitKbd();

extern "C" void delay (unsigned int __milliseconds);
