// ElSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ElSetup.h"
#include "ElSetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CElSetupDlg dialog

CElSetupDlg::CElSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CElSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CElSetupDlg)
	m_iVideoMode = -1;
	m_bEnablePlasma = FALSE;
	m_bEnableSound = FALSE;
	m_bEnableMusic = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CElSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CElSetupDlg)
	DDX_Control(pDX, IDC_LENGTH_SLIDER, m_LengthSlider);
	DDX_Control(pDX, IDC_SPEED_SLIDER, m_SpeedSlider);
	DDX_Radio(pDX, IDC_RADIO1, m_iVideoMode);
	DDX_Check(pDX, IDC_ENABLE_PLASMA, m_bEnablePlasma);
	DDX_Check(pDX, IDC_ENABLE_SOUND, m_bEnableSound);
	DDX_Check(pDX, IDC_ENABLE_MUSIC, m_bEnableMusic);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CElSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CElSetupDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CElSetupDlg message handlers

BOOL CElSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_SpeedSlider.SetRange (1, 20);
    m_SpeedSlider.SetTic (10);

    m_LengthSlider.SetRange (30, 300);
    m_LengthSlider.SetTic (60);
    m_LengthSlider.SetTic (120);
    m_LengthSlider.SetTic (180);
    m_LengthSlider.SetTic (240);
    
    GetModuleFileName (NULL, m_sAppName, 259);
    char *p=strrchr (m_sAppName, '\\');
    strcpy (p+1, "elsocc.ini");
          
    m_bEnablePlasma=GetPrivateProfileInt ("ElSocc", "EnablePlasma", 1, m_sAppName);
    m_bEnableSound=GetPrivateProfileInt ("ElSocc", "EnableSound", 1, m_sAppName);
    m_bEnableMusic=GetPrivateProfileInt ("ElSocc", "EnableMusic", 1, m_sAppName);
    m_iVideoMode=GetPrivateProfileInt ("ElSocc", "VideoMode", 0, m_sAppName);

    int iGameSpeed=GetPrivateProfileInt ("ElSocc", "GameSpeed", 10, m_sAppName);
    if (iGameSpeed < 10)
        m_SpeedSlider.SetPos (iGameSpeed);
    else
        m_SpeedSlider.SetPos (10 + (iGameSpeed-10) / 2);

    int iGameLength=GetPrivateProfileInt ("ElSocc", "GameLength", 60, m_sAppName);
    m_LengthSlider.SetPos (iGameLength);
	
    UpdateData (FALSE);
    
    return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CElSetupDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CElSetupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CElSetupDlg::OnOK() 
{
	UpdateData (TRUE);
    
    char sBuf [40];
    
    WritePrivateProfileString ("ElSocc", "EnablePlasma", itoa (m_bEnablePlasma, sBuf, 10),
        m_sAppName);
    WritePrivateProfileString ("ElSocc", "EnableSound", itoa (m_bEnableSound, sBuf, 10),
        m_sAppName);
    WritePrivateProfileString ("ElSocc", "EnableMusic", itoa (m_bEnableMusic, sBuf, 10),
        m_sAppName);
    WritePrivateProfileString ("ElSocc", "VideoMode", itoa (m_iVideoMode, sBuf, 10),
        m_sAppName);

    int iSliderPos=m_SpeedSlider.GetPos();
    int iGameSpeed;
    if (iSliderPos < 10)
        iGameSpeed = iSliderPos;
    else
        iGameSpeed = 10 + (iSliderPos-10) * 2;
    WritePrivateProfileString ("ElSocc", "GameSpeed", itoa (iGameSpeed, sBuf, 10),
        m_sAppName);
	
	WritePrivateProfileString ("ElSocc", "GameLength",
        itoa (m_LengthSlider.GetPos(), sBuf, 10), m_sAppName);
    
    CDialog::OnOK();
}
