/****************************************************************************\
*  *
* File 'el_dos.cpp'   - Electron Soccer v 1.1, DOS only code                 *
* Project started     - 14:54:21, 18-11-97                                   *
* Last modifyed       - 22:11:28, 12-05-98                                   *
*                                                                            *
* Written by EXeLENZ (55:1055/2@general, 2:5030/448.1@fidonet)               *
* Win32 version written by Yoletir / FaerieFire AKA Dmitry Jemerov,          *
*                                                              2:5030/654    *
*  *
\****************************************************************************/

#include <conio.h>
#include <dos.h>
#include <i86.h>
#include <mem.h>
#include <stdio.h>
#include <stdlib.h>

#include <fxRes.h>

#include "el_socc.h"

void (__interrupt __far *old_int9) (); /* Old int 9                         */
void interrupt isr_int9 (void);
char Real9Handler = 0;                 /*  ࠡ稪  9       */

int VidMaxX, VidMaxY;

/****************************************************************************\
* Function : Elhelp                                                          *
* Desc     : Writes help screen and exits                                    *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void Elhelp (void) {
   printf ("\nElectron Soccer 1.0 by EXeLENZ of [FaerieFire]");
   printf ("\nCompiled at [%s / %s]\n",__DATE__,__TIME__);
   puts ("\nUsage: ff_els10 [options]");
   puts ("[options] are:");
   puts ("  /nosound  - disable sound and musax ");
   puts ("              you have to use this option under Windows NT");
   puts ("  /noplasma - disable plasma");
   puts ("              this improves performance, use it on slow machines");
   puts ("  /setup    - sound card configuration,  use it if autoconfiguration fails");
   puts ("              you may also decrease mixing rate to improve performance\n");
   puts ("  /help     - this screen\n");
   exit (1);
}

/****************************************************************************\
*  *
*  稭 ...  ᫥,  main 稭 =)                     *
*  *
\****************************************************************************/

void main (int argc, char *argv[])
{
#ifdef USE_MIDAS
   m_error=(int)rad;
#endif

   // ࠡ⠥ ࠬ  ப.
   if ((!stricmp (argv [1], "/?"))    ||
       (!stricmp (argv [1], "-?"))    ||
       (!stricmp (argv [1], "-help")) ||
       (!stricmp (argv [1], "/help"))) Elhelp();

   if (!stricmp (argv [1], "/nosound"))              NOSOUND=YES;
   if (!stricmp (argv [1], "-nosound"))              NOSOUND=YES;
   if (argc>2){if (!stricmp (argv [2], "/nosound"))  NOSOUND=YES;}
   if (argc>2){if (!stricmp (argv [2], "-nosound"))  NOSOUND=YES;}

   if (!stricmp (argv [1], "/noplasma"))             NOPLASMA=YES;
   if (!stricmp (argv [1], "-noplasma"))             NOPLASMA=YES;
   if (argc>2){if (!stricmp (argv [2], "/noplasma")) NOPLASMA=YES;}
   if (argc>2){if (!stricmp (argv [2], "-noplasma")) NOPLASMA=YES;}

#ifdef USE_MIDAS
   MIDASstartup ();

   if (!stricmp (argv [1], "/setup")) {
       if (MIDASconfig () != 0) {
          MIDASsaveConfig ("sound.cfg");
       } else {
          printf ("\nESC pressed, exiting ...\n");
          exit (1);
       }
   }

   // ⠥ ⤥⥪ 㭤 
   MIDASdetectSD ();

   FILE *cfg=fopen ("sound.cfg","rb");
   if (cfg != NULL) {
      fclose (cfg);
      MIDASloadConfig ("SOUND.CFG");
   }
#endif USE_MIDAS

   // ⠢ ᢮ ࠡ稪  9-.
   old_int9=_dos_getvect (0x9);
   _dos_setvect (0x9,isr_int9);

   // ⥪⨬ .
   if (EGLvesaDetect ()!=EGLyes) {
      printf ("\nNo VESA found.\n Please install UniVBE 5.3 or newer !\n");
      exit (1);
   }

   // ⠥ ⠢ 320/200/16
   if (EGLsetMode (EGL320x200x16)!=EGLok) {
      printf("Unable to set VESA 320x200x16bpp gfx mode.\nNeed VBE >= 2.0\n");
      printf("Please install UniVBE 5.3 or newer.\n");
      exit(1);
   }
   VidMaxX = 320; VidMaxY = 200;

   // Init bound resource.
   if (!ResInitFile ("els.res")) {
      puts ("[Err] Cannot open resource file");
      exit (1);
   }

   ElSoccMain();

   // 頥   .
   _dos_setvect (0x9,old_int9);

   ElSoccDone();
}

void ProcessMessages()
{
}

/****************************************************************************\
* Function : isr_int9                                                        *
* Desc     : Handles 9 int (updates key state in keymap)                     *
* Input    : None                                                            *
* Output   : None                                                            *
\****************************************************************************/
void interrupt isr_int9 (void) {

   char temp,scancode;

   _disable ();

   scancode=inp (0x60);

   if (!Real9Handler) {

      if (scancode<128) keymap [scancode]=PRESSED;
      else keymap [scancode-128]=DEPRESSED;

      outp (0x61,(temp=inp (0x61))|0x80);
      outp (0x61,temp);

      outp (0x20,0x20); // Eoi

      _enable ();
   }

   else {
      _enable ();
      old_int9 ();
   }
}

void DeinitKbd()
{
   // 頥   .
   _dos_setvect (0x9,old_int9);
}

/****************************************************************************\
* Function : Error                                                           *
* Desc     : 砥 ண,  稭.                                   *
* Input    : 稭                                                         *
* Output   :                                                             *
\****************************************************************************/
void Error (int cause) {

   EGLterminate ();

   if (cause==ErrAlloc) {
      printf ("\nUnable to allocate memory for block.\nExiting.\n");
   }
   if (cause==ErrMusax) {
      printf ("\nTrouble with audio engine, sorry.\nExiting.\n");
   }

   _dos_setvect (0x9,old_int9);

   exit (cause);
}

/****************************************************************************\
* Function : EGLtrace                                                        *
* Desc     : ⫠筠                                                *
* Input    : ଠ⭠ ப, 㬥                                     *
* Output   :                                                              *
\****************************************************************************/
void __cdecl EGLtrace (char *fmt, ...)
{
   // stub. we could write to debug file
}
